/*
** DBC/PUT.REXX
**
** $VER: DBC/PUT.REXX 1.0.0 (01.04.96)
**
** This ARexx script is for use with Hollywood FX.  
** This script converts RGB images from LightWave
** to the Digital Broadcaster as a JStream.
**
** This script requires ADPro v2.5.0 (or higher).
**
** Copyright  1995 Synergy International, Incorporated
** All Rights Reserved
** 
** The following copyright notice applies to the Locate-ADPro
** code included in this script:
**
** Copyright  1991-1993 ASDG, Incorporated
** All Rights Reserved
*/

OPTIONS RESULTS

/******************************************************/
/* User Settings                                      */
/******************************************************/

Appender = "Producer:Tools/AppendJPEG"
RefJStream = "Video:jref.jst"
Horz = 720                      
Vert = 480                    /* Change to 576 for PAL */

/******************************************************/
/* Start of Script                                    */
/******************************************************/

PARSE ARG inname ',' outname

Quality = "QUALITY 16 TABLES " || RefJStream

tmp = RIGHT(outname, LENGTH(outname) - 5)       /* Remove DBC#: at front of name */
tmp2 = LEFT(tmp, LENGTH(tmp) - 4)               /* Remove .jst at end of name */
field0 = "T:" || tmp2 || ".jf0"                
field1 = "T:" || tmp2 || ".jf1"
field = "T:" || tmp2

/*** Check if ADPro is loaded, if not try to load ***/

CALL Locate_ADPro

/*** Could not load ADPro, exit script ***/

IF (RESULT = 0) THEN
  EXIT 10

/******************************************************************************/

ADDRESS "ADPro"

/*** Load image to convert ***/

LOAD_TYPE "REPLACE"
LOADER "UNIVERSAL" inname

/*** Scale it to proper size and de-interlace it***/

ABS_SCALE Horz Vert
OPERATOR "DEINTERLACE"

SAVER "TEMP" "XXX" "RAW"
OPERATOR "CROP_IMAGE" Horz (Vert / 2) 0 0
SAVER "JPEG" field1 "RAW" /* Quality */

LOADER "TEMP" "XXX"
OPERATOR "CROP_IMAGE" Horz (Vert / 2) 0 (Vert / 2)
SAVER "JPEG" field0 "RAW" /* Quality */

ADDRESS COMMAND
Appender outname field
delete field0
delete field1

EXIT (0)

/******************************************************************************/
  
/*** Locate_ADPro function provided by ASDG, Inc. ***/

Locate_ADPro:
   Max_Seconds_To_Load = 60
   Flag = 0
   LibName = 'rexxsupport.library'

   IF (POS( LibName, SHOW( 'Libraries' ) ) = 0) THEN
      ADDLIB( LibName, 0, -30, 0 )
   IF (POS( LibName, SHOW( 'Libraries' ) ) = 0) THEN
      RETURN 0

   IF (STATEF( 'ADPRO:' ) = "") THEN
      RETURN 0

   TIME( 'R' )
   DO WHILE (TIME( 'E' ) < Max_Seconds_To_Load) & (POS( 'ADPro', SHOW( 'Ports' ) ) = 0)
      IF (Flag = 0) THEN DO
         /* Set whatever command line arguments you want. */
         ADDRESS COMMAND 'Run < NIL: > NIL: ADPRO:ADPro MINIMIZED'
         Flag = 1
      END
      ADDRESS COMMAND 'Wait 1'
   END
   IF (POS( 'ADPro', SHOW( 'Ports' ) ) = 0) THEN
      RETURN 0
   ELSE
      RETURN 1
